(function() {"use strict";var __module = CC_EDITOR ? module : {exports:{}};var __filename = 'preview-scripts/assets/Script/main.js';var __require = CC_EDITOR ? function (request) {return cc.require(request, require);} : function (request) {return cc.require(request, __filename);};function __define (exports, require, module) {"use strict";
cc._RF.push(module, 'efaackO/xlGBKzkVm2CWoi3', 'main', __filename);
// Script/main.ts

Object.defineProperty(exports, "__esModule", { value: true });
var Gas_1 = require("./Gas");
var MD_1 = require("./MD");
var _a = cc._decorator, ccclass = _a.ccclass, property = _a.property;
var main = /** @class */ (function (_super) {
    __extends(main, _super);
    function main() {
        var _this = _super.call(this) || this;
        _this.time = 3;
        _this.startPos = null;
        _this.endPos = null;
        _this.moveNode = null;
        _this.speed = 500;
        _this.gasPrefab = null;
        _this.gasParent = null;
        _this.gasNodePool = null;
        _this.hpBar = null;
        _this.hp = 100;
        _this.qipao23 = null;
        MD_1.MD.main = _this;
        return _this;
    }
    main.prototype.onLoad = function () {
        cc.director.getCollisionManager().enabled = true;
        // this.moveNode.on(cc.Node.EventType.TOUCH_MOVE, this.move, this)
        this.node.on(cc.Node.EventType.TOUCH_START, this.click, this);
        this.node.on('gas', this.gas, this);
        this.gasNodePool = new cc.NodePool(Gas_1.default);
        for (var i = 0; i < 100; i++) {
            var node = cc.instantiate(this.gasPrefab);
            this.gasNodePool.put(node);
        }
    };
    main.prototype.hit = function () {
        this.hp -= 1;
        this.hpBar.progress = this.hp / 100;
    };
    main.prototype.recover = function () {
        this.hp = 100;
        this.hpBar.progress = 1;
    };
    main.prototype.click = function (event) {
        var gas = this.gasNodePool.get();
        // let pos = this.node.convertToNodeSpaceAR(event.getLocation()) //点击出现
        var pos = this.outPos;
        gas.setPosition(pos);
        gas.parent = this.gasParent;
    };
    Object.defineProperty(main.prototype, "outPos", {
        /**获取随机外面位置 */
        get: function () {
            var dir = Math.round(Math.random() * 3);
            var x, y;
            switch (dir) {
                case 0: //left
                    x = -360;
                    y = Math.random() * 640 * (Math.random() > 0.5 ? -1 : 1);
                    break;
                case 1: //right
                    x = 360;
                    y = Math.random() * 640 * (Math.random() > 0.5 ? -1 : 1);
                    break;
                case 2: //top
                    x = Math.random() * 360 * (Math.random() > 0.5 ? -1 : 1);
                    y = 640;
                    break;
                case 3: //down 
                    x = Math.random() * 360 * (Math.random() > 0.5 ? -1 : 1);
                    y = -640;
                    break;
            }
            return new cc.Vec2(x, y);
        },
        enumerable: true,
        configurable: true
    });
    main.prototype.move = function (event) {
        this.moveNode.x += event.getDeltaX();
        this.moveNode.y += event.getDeltaY();
    };
    main.prototype.gas = function (msg, target) {
        this.gasNodePool.put(target);
    };
    main.prototype.update = function (dt) {
        return;
        // var delta = cc.pSub(this.moveNode.getPosition(), this.node.getPosition())
        var delta = this.moveNode.getPosition().sub(this.node.getPosition());
        // var distance = cc.pDistance(this.moveNode.getPosition(), this.node.getPosition())
        var distance = delta.mag();
        var pos = this.moveNode.getPosition();
        var angle = cc.misc.radiansToDegrees(Math.atan2(pos.x - this.node.x, pos.y - this.node.y));
        this.node.rotation = angle;
        this.node.y += this.speed * dt * delta.y / distance;
        this.node.x += this.speed * dt * delta.x / distance;
    };
    main.prototype.onEnable = function () {
        // let movetoL = cc.moveTo(this.time,cc.v2(700,-207)) 
        // let movetoL = cc.moveTo(this.time,this.startPos) 
        // let delay = cc.delayTime(1)
        // // let movetoR = cc.moveTo(this.time,cc.v2(-700,-207))
        // let movetoR = cc.moveTo(this.time,this.endPos)
        // let seq = cc.sequence(movetoL,delay,movetoR,delay) 
        // this.node.runAction(cc.repeatForever(seq))
    };
    __decorate([
        property(cc.Vec2)
    ], main.prototype, "startPos", void 0);
    __decorate([
        property(cc.Vec2)
    ], main.prototype, "endPos", void 0);
    __decorate([
        property(cc.Node)
    ], main.prototype, "moveNode", void 0);
    __decorate([
        property(cc.Prefab)
    ], main.prototype, "gasPrefab", void 0);
    __decorate([
        property(cc.Node)
    ], main.prototype, "gasParent", void 0);
    __decorate([
        property(cc.ProgressBar)
    ], main.prototype, "hpBar", void 0);
    __decorate([
        property(cc.SpriteFrame)
    ], main.prototype, "qipao23", void 0);
    main = __decorate([
        ccclass
    ], main);
    return main;
}(cc.Component));
exports.default = main;

cc._RF.pop();
        }
        if (CC_EDITOR) {
            __define(__module.exports, __require, __module);
        }
        else {
            cc.registerModuleFunc(__filename, function () {
                __define(__module.exports, __require, __module);
            });
        }
        })();
        //# sourceMappingURL=main.js.map
        