"use strict";
cc._RF.push(module, 'f01018toItHFLawokQYomW/', 'Enemy');
// Script/Enemy.ts

Object.defineProperty(exports, "__esModule", { value: true });
var MD_1 = require("./MD");
var _a = cc._decorator, ccclass = _a.ccclass, property = _a.property;
var Enemy = /** @class */ (function (_super) {
    __extends(Enemy, _super);
    function Enemy() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.angle = 0;
        _this.speed = 200;
        return _this;
    }
    Enemy.prototype.onEnable = function () {
        // console.error('show')
    };
    Enemy.prototype.update = function (dt) {
        if (this.node.x > 350 - this.node.width / 2 || this.node.x < -350 + this.node.width / 2 || this.node.y > 630 - this.node.height / 2 || this.node.y < -630 + this.node.height / 2) {
            MD_1.MD.main.hit();
            MD_1.MD.Boss.node.emit('boss', '', this.node);
            return;
        }
        this.node.x += dt * this.speed * Math.sin(this.angle);
        this.node.y += dt * this.speed * Math.cos(this.angle);
    };
    Enemy.prototype.onCollisionEnter = function (other, self) {
        MD_1.MD.Boss.node.emit('boss', '', this.node);
        // this.node.parent.emit('boss','',this.node)
    };
    Enemy.prototype.reuse = function () {
        // console.error('使用')
        var r = Math.random() * 90;
        this.angle = Math.random() * 360;
        // this.angle = 90
        var x = r * Math.sin(this.angle);
        var y = r * Math.cos(this.angle);
        // this.node.setPosition()
        this.node.x = x;
        this.node.y = y;
    };
    Enemy.prototype.unuse = function () {
        // console.error('回收')
    };
    Enemy = __decorate([
        ccclass
    ], Enemy);
    return Enemy;
}(cc.Component));
exports.default = Enemy;

cc._RF.pop();